Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -6300,16 +6336,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 049eah                          ; 75 0d
+    jne short 04a09h                          ; 75 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 049eah                          ; 76 08
+    jbe short 04a09h                          ; 76 08
     mov AL, strict byte 011h                  ; b0 11
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 049d3h                          ; eb e9
+    jmp short 049f2h                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 049f4h                          ; 75 06
+    jne short 04a13h                          ; 75 06
     mov ax, strict word 0000bh                ; b8 0b 00
-    call 04932h                               ; e8 3e ff
+    call 04951h                               ; e8 3e ff
     mov dx, strict word 00060h                ; ba 60 00
     in AL, DX                                 ; ec
@@ -6317,7 +6353,7 @@
     ; sub ah, ah                                ; 2a e4
     test ax, ax                               ; 85 c0
-    je short 04a04h                           ; 74 06
+    je short 04a23h                           ; 74 06
     mov ax, 003e0h                            ; b8 e0 03
-    call 04932h                               ; e8 2e ff
+    call 04951h                               ; e8 2e ff
     mov AL, strict byte 0ffh                  ; b0 ff
     mov dx, strict word 00060h                ; ba 60 00
@@ -6329,16 +6365,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 002h                 ; a8 02
-    je short 04a24h                           ; 74 0d
+    je short 04a43h                           ; 74 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 04a24h                          ; 76 08
+    jbe short 04a43h                          ; 76 08
     mov AL, strict byte 020h                  ; b0 20
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 04a0dh                          ; eb e9
+    jmp short 04a2ch                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 04a2eh                          ; 75 06
+    jne short 04a4dh                          ; 75 06
     mov ax, strict word 00014h                ; b8 14 00
-    call 04932h                               ; e8 04 ff
+    call 04951h                               ; e8 04 ff
     mov bx, strict word 0ffffh                ; bb ff ff
     mov dx, strict word 00064h                ; ba 64 00
@@ -6347,16 +6383,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 04a48h                          ; 75 0d
+    jne short 04a67h                          ; 75 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 04a48h                          ; 76 08
+    jbe short 04a67h                          ; 76 08
     mov AL, strict byte 021h                  ; b0 21
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 04a31h                          ; eb e9
+    jmp short 04a50h                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 04a52h                          ; 75 06
+    jne short 04a71h                          ; 75 06
     mov ax, strict word 00015h                ; b8 15 00
-    call 04932h                               ; e8 e0 fe
+    call 04951h                               ; e8 e0 fe
     mov dx, strict word 00060h                ; ba 60 00
     in AL, DX                                 ; ec
@@ -6364,7 +6400,7 @@
     ; sub ah, ah                                ; 2a e4
     cmp ax, 000fah                            ; 3d fa 00
-    je short 04a63h                           ; 74 06
+    je short 04a82h                           ; 74 06
     mov ax, 003e1h                            ; b8 e1 03
-    call 04932h                               ; e8 cf fe
+    call 04951h                               ; e8 cf fe
     mov bx, strict word 0ffffh                ; bb ff ff
     mov dx, strict word 00064h                ; ba 64 00
@@ -6373,16 +6409,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 04a7dh                          ; 75 0d
+    jne short 04a9ch                          ; 75 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 04a7dh                          ; 76 08
+    jbe short 04a9ch                          ; 76 08
     mov AL, strict byte 031h                  ; b0 31
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 04a66h                          ; eb e9
+    jmp short 04a85h                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 04a87h                          ; 75 06
+    jne short 04aa6h                          ; 75 06
     mov ax, strict word 0001fh                ; b8 1f 00
-    call 04932h                               ; e8 ab fe
+    call 04951h                               ; e8 ab fe
     mov dx, strict word 00060h                ; ba 60 00
     in AL, DX                                 ; ec
@@ -6390,12 +6426,12 @@
     ; sub ah, ah                                ; 2a e4
     cmp ax, 000aah                            ; 3d aa 00
-    je short 04aa0h                           ; 74 0e
+    je short 04abfh                           ; 74 0e
     in AL, DX                                 ; ec
     db  02ah, 0e4h
     ; sub ah, ah                                ; 2a e4
     cmp ax, 000aah                            ; 3d aa 00
-    je short 04aa0h                           ; 74 06
+    je short 04abfh                           ; 74 06
     mov ax, 003e2h                            ; b8 e2 03
-    call 04932h                               ; e8 92 fe
+    call 04951h                               ; e8 92 fe
     mov AL, strict byte 0f5h                  ; b0 f5
     mov dx, strict word 00060h                ; ba 60 00
@@ -6407,16 +6443,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 002h                 ; a8 02
-    je short 04ac0h                           ; 74 0d
+    je short 04adfh                           ; 74 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 04ac0h                          ; 76 08
+    jbe short 04adfh                          ; 76 08
     mov AL, strict byte 040h                  ; b0 40
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 04aa9h                          ; eb e9
+    jmp short 04ac8h                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 04acah                          ; 75 06
+    jne short 04ae9h                          ; 75 06
     mov ax, strict word 00028h                ; b8 28 00
-    call 04932h                               ; e8 68 fe
+    call 04951h                               ; e8 68 fe
     mov bx, strict word 0ffffh                ; bb ff ff
     mov dx, strict word 00064h                ; ba 64 00
@@ -6425,16 +6461,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 04ae4h                          ; 75 0d
+    jne short 04b03h                          ; 75 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 04ae4h                          ; 76 08
+    jbe short 04b03h                          ; 76 08
     mov AL, strict byte 041h                  ; b0 41
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 04acdh                          ; eb e9
+    jmp short 04aech                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 04aeeh                          ; 75 06
+    jne short 04b0dh                          ; 75 06
     mov ax, strict word 00029h                ; b8 29 00
-    call 04932h                               ; e8 44 fe
+    call 04951h                               ; e8 44 fe
     mov dx, strict word 00060h                ; ba 60 00
     in AL, DX                                 ; ec
@@ -6442,7 +6478,7 @@
     ; sub ah, ah                                ; 2a e4
     cmp ax, 000fah                            ; 3d fa 00
-    je short 04affh                           ; 74 06
+    je short 04b1eh                           ; 74 06
     mov ax, 003e3h                            ; b8 e3 03
-    call 04932h                               ; e8 33 fe
+    call 04951h                               ; e8 33 fe
     mov AL, strict byte 060h                  ; b0 60
     mov dx, strict word 00064h                ; ba 64 00
@@ -6454,16 +6490,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 002h                 ; a8 02
-    je short 04b1fh                           ; 74 0d
+    je short 04b3eh                           ; 74 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 04b1fh                          ; 76 08
+    jbe short 04b3eh                          ; 76 08
     mov AL, strict byte 050h                  ; b0 50
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 04b08h                          ; eb e9
+    jmp short 04b27h                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 04b29h                          ; 75 06
+    jne short 04b48h                          ; 75 06
     mov ax, strict word 00032h                ; b8 32 00
-    call 04932h                               ; e8 09 fe
+    call 04951h                               ; e8 09 fe
     mov AL, strict byte 065h                  ; b0 65
     mov dx, strict word 00060h                ; ba 60 00
@@ -6475,16 +6511,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 002h                 ; a8 02
-    je short 04b49h                           ; 74 0d
+    je short 04b68h                           ; 74 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 04b49h                          ; 76 08
+    jbe short 04b68h                          ; 76 08
     mov AL, strict byte 060h                  ; b0 60
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 04b32h                          ; eb e9
+    jmp short 04b51h                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 04b53h                          ; 75 06
+    jne short 04b72h                          ; 75 06
     mov ax, strict word 0003ch                ; b8 3c 00
-    call 04932h                               ; e8 df fd
+    call 04951h                               ; e8 df fd
     mov AL, strict byte 0f4h                  ; b0 f4
     mov dx, strict word 00060h                ; ba 60 00
@@ -6496,16 +6532,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 002h                 ; a8 02
-    je short 04b73h                           ; 74 0d
+    je short 04b92h                           ; 74 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 04b73h                          ; 76 08
+    jbe short 04b92h                          ; 76 08
     mov AL, strict byte 070h                  ; b0 70
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 04b5ch                          ; eb e9
+    jmp short 04b7bh                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 04b7dh                          ; 75 06
+    jne short 04b9ch                          ; 75 06
     mov ax, strict word 00046h                ; b8 46 00
-    call 04932h                               ; e8 b5 fd
+    call 04951h                               ; e8 b5 fd
     mov bx, strict word 0ffffh                ; bb ff ff
     mov dx, strict word 00064h                ; ba 64 00
@@ -6514,16 +6550,16 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 04b97h                          ; 75 0d
+    jne short 04bb6h                          ; 75 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 04b97h                          ; 76 08
+    jbe short 04bb6h                          ; 76 08
     mov AL, strict byte 071h                  ; b0 71
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 04b80h                          ; eb e9
+    jmp short 04b9fh                          ; eb e9
     test bx, bx                               ; 85 db
-    jne short 04ba1h                          ; 75 06
+    jne short 04bc0h                          ; 75 06
     mov ax, strict word 00046h                ; b8 46 00
-    call 04932h                               ; e8 91 fd
+    call 04951h                               ; e8 91 fd
     mov dx, strict word 00060h                ; ba 60 00
     in AL, DX                                 ; ec
@@ -6531,16 +6567,16 @@
     ; sub ah, ah                                ; 2a e4
     cmp ax, 000fah                            ; 3d fa 00
-    je short 04bb2h                           ; 74 06
+    je short 04bd1h                           ; 74 06
     mov ax, 003e4h                            ; b8 e4 03
-    call 04932h                               ; e8 80 fd
+    call 04951h                               ; e8 80 fd
     mov AL, strict byte 0a8h                  ; b0 a8
     mov dx, strict word 00064h                ; ba 64 00
     out DX, AL                                ; ee
     xor ax, ax                                ; 31 c0
-    call 05e2ch                               ; e8 6f 12
+    call 05e4bh                               ; e8 6f 12
     mov sp, bp                                ; 89 ec
     pop bp                                    ; 5d
     retn                                      ; c3
-enqueue_key_:                                ; 0xf4bc1 LB 0x93
+enqueue_key_:                                ; 0xf4be0 LB 0x93
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -6554,30 +6590,30 @@
     mov dx, strict word 0001ah                ; ba 1a 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 45 ca
+    call 0161ch                               ; e8 26 ca
     mov di, ax                                ; 89 c7
     mov dx, strict word 0001ch                ; ba 1c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 3a ca
+    call 0161ch                               ; e8 1b ca
     mov si, ax                                ; 89 c6
     lea cx, [si+002h]                         ; 8d 4c 02
     cmp cx, strict byte 0003eh                ; 83 f9 3e
-    jc short 04befh                           ; 72 03
+    jc short 04c0eh                           ; 72 03
     mov cx, strict word 0001eh                ; b9 1e 00
     cmp cx, di                                ; 39 f9
-    jne short 04bf7h                          ; 75 04
+    jne short 04c16h                          ; 75 04
     xor ax, ax                                ; 31 c0
-    jmp short 04c1ch                          ; eb 25
+    jmp short 04c3bh                          ; eb 25
     xor bh, bh                                ; 30 ff
     mov dx, si                                ; 89 f2
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 0d ca
+    call 0160eh                               ; e8 ee c9
     movzx bx, byte [bp-00ah]                  ; 0f b6 5e f6
     lea dx, [si+001h]                         ; 8d 54 01
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 00 ca
+    call 0160eh                               ; e8 e1 c9
     mov bx, cx                                ; 89 cb
     mov dx, strict word 0001ch                ; ba 1c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0162ah                               ; e8 11 ca
+    call 0162ah                               ; e8 f2 c9
     mov ax, strict word 00001h                ; b8 01 00
     lea sp, [bp-008h]                         ; 8d 66 f8
@@ -6597,19 +6633,27 @@
     cmp bh, byte [bx+si]                      ; 3a 38
     sub bl, byte [ss:di]                      ; 36 2a 1d
-    mov cs, [bp+01bh]                         ; 8e 4e 1b
+    lodsw                                     ; ad
+    dec si                                    ; 4e
+    cmp cl, byte [di+009h]                    ; 3a 4d 09
     dec bp                                    ; 4d
-    jmp far 09d4ch:0ea4ch                     ; ea 4c ea 4c 9d
+    or word [di-044h], cx                     ; 09 4d bc
     dec bp                                    ; 4d
-    retn                                      ; c3
+    loop 04cabh                               ; e2 4c
+    db  02eh, 04eh
+    ; cs dec si                                 ; 2e 4e
+    jnl short 04cb1h                          ; 7d 4e
+    mov AL, byte [07b4eh]                     ; a0 4e 7b
+    dec bp                                    ; 4d
+    or word [di+009h], cx                     ; 09 4d 09
+    dec bp                                    ; 4d
+    cmc                                       ; f5
+    dec bp                                    ; 4d
+    sti                                       ; fb
     dec sp                                    ; 4c
-    cmovle bx, word [bp+04eh]                 ; 0f 4e 5e 4e
-    or word [bp+05ch], 0ea4dh                 ; 81 4e 5c 4d ea
-    dec sp                                    ; 4c
-    jmp far 0dc4dh:0d64ch                     ; ea 4c d6 4d dc
-    dec sp                                    ; 4c
-    aas                                       ; 3f
+    pop si                                    ; 5e
     dec si                                    ; 4e
-    jp short 04ca2h                           ; 7a 4e
-_int09_function:                             ; 0xf4c54 LB 0x35d
+    cwd                                       ; 99
+    dec si                                    ; 4e
+_int09_function:                             ; 0xf4c73 LB 0x35d
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -6620,27 +6664,27 @@
     mov byte [bp-00ah], al                    ; 88 46 f6
     test al, al                               ; 84 c0
-    jne short 04c7fh                          ; 75 19
-    mov bx, 00da6h                            ; bb a6 0d
+    jne short 04c9eh                          ; 75 19
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 5b cc
+    call 018e1h                               ; e8 51 cc
     push 00567h                               ; 68 67 05
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 94 cc
+    call 01922h                               ; e8 8a cc
     add sp, strict byte 00004h                ; 83 c4 04
-    jmp near 04faah                           ; e9 2b 03
+    jmp near 04fc9h                           ; e9 2b 03
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 78 c9
+    call 01600h                               ; e8 59 c9
     mov byte [bp-00eh], al                    ; 88 46 f2
     mov bl, al                                ; 88 c3
     mov dx, strict word 00018h                ; ba 18 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 6a c9
+    call 01600h                               ; e8 4b c9
     mov byte [bp-010h], al                    ; 88 46 f0
     mov byte [bp-00ch], al                    ; 88 46 f4
     mov dx, 00096h                            ; ba 96 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 5b c9
+    call 01600h                               ; e8 3c c9
     mov byte [bp-008h], al                    ; 88 46 f8
     mov byte [bp-006h], al                    ; 88 46 fa
@@ -6649,9 +6693,9 @@
     pop ES                                    ; 07
     mov cx, strict word 00010h                ; b9 10 00
-    mov di, 04c25h                            ; bf 25 4c
+    mov di, 04c44h                            ; bf 44 4c
     repne scasb                               ; f2 ae
     sal cx, 1                                 ; d1 e1
     mov di, cx                                ; 89 cf
-    mov ax, word [cs:di+04c34h]               ; 2e 8b 85 34 4c
+    mov ax, word [cs:di+04c53h]               ; 2e 8b 85 53 4c
     jmp ax                                    ; ff e0
     xor bl, 040h                              ; 80 f3 40
@@ -6659,15 +6703,15 @@
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 3d c9
+    call 0160eh                               ; e8 1e c9
     or byte [bp-00ch], 040h                   ; 80 4e f4 40
     movzx bx, byte [bp-00ch]                  ; 0f b6 5e f4
-    jmp near 04e52h                           ; e9 76 01
+    jmp near 04e71h                           ; e9 76 01
     mov al, byte [bp-010h]                    ; 8a 46 f0
     and AL, strict byte 0bfh                  ; 24 bf
     mov byte [bp-00ch], al                    ; 88 46 f4
     movzx bx, al                              ; 0f b6 d8
-    jmp near 04e52h                           ; e9 68 01
+    jmp near 04e71h                           ; e9 68 01
     test byte [bp-006h], 002h                 ; f6 46 fa 02
-    jne near 04f8ch                           ; 0f 85 9a 02
+    jne near 04fabh                           ; 0f 85 9a 02
     mov al, byte [bp-00ah]                    ; 8a 46 f6
     and AL, strict byte 07fh                  ; 24 7f
@@ -6678,29 +6722,29 @@
     inc ax                                    ; 40
     test byte [bp-00ah], 080h                 ; f6 46 f6 80
-    je short 04d0bh                           ; 74 06
+    je short 04d2ah                           ; 74 06
     not al                                    ; f6 d0
     and bl, al                                ; 20 c3
-    jmp short 04d0dh                          ; eb 02
+    jmp short 04d2ch                          ; eb 02
     or bl, al                                 ; 08 c3
     xor bh, bh                                ; 30 ff
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 f6 c8
-    jmp near 04f8ch                           ; e9 71 02
+    call 0160eh                               ; e8 d7 c8
+    jmp near 04fabh                           ; e9 71 02
     test byte [bp-008h], 001h                 ; f6 46 f8 01
-    jne near 04f8ch                           ; 0f 85 69 02
+    jne near 04fabh                           ; 0f 85 69 02
     or bl, 004h                               ; 80 cb 04
     xor bh, bh                                ; 30 ff
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 dd c8
+    call 0160eh                               ; e8 be c8
     mov al, byte [bp-008h]                    ; 8a 46 f8
     test AL, strict byte 002h                 ; a8 02
-    je short 04d45h                           ; 74 0d
+    je short 04d64h                           ; 74 0d
     or AL, strict byte 004h                   ; 0c 04
     mov byte [bp-006h], al                    ; 88 46 fa
     movzx bx, al                              ; 0f b6 d8
     mov dx, 00096h                            ; ba 96 00
-    jmp short 04d53h                          ; eb 0e
+    jmp short 04d72h                          ; eb 0e
     mov al, byte [bp-010h]                    ; 8a 46 f0
     or AL, strict byte 001h                   ; 0c 01
@@ -6709,21 +6753,21 @@
     mov dx, strict word 00018h                ; ba 18 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 b5 c8
-    jmp near 04f8ch                           ; e9 30 02
+    call 0160eh                               ; e8 96 c8
+    jmp near 04fabh                           ; e9 30 02
     test byte [bp-008h], 001h                 ; f6 46 f8 01
-    jne near 04f8ch                           ; 0f 85 28 02
+    jne near 04fabh                           ; 0f 85 28 02
     and bl, 0fbh                              ; 80 e3 fb
     xor bh, bh                                ; 30 ff
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 9c c8
+    call 0160eh                               ; e8 7d c8
     mov al, byte [bp-008h]                    ; 8a 46 f8
     test AL, strict byte 002h                 ; a8 02
-    je short 04d86h                           ; 74 0d
+    je short 04da5h                           ; 74 0d
     and AL, strict byte 0fbh                  ; 24 fb
     mov byte [bp-006h], al                    ; 88 46 fa
     movzx bx, al                              ; 0f b6 d8
     mov dx, 00096h                            ; ba 96 00
-    jmp short 04d94h                          ; eb 0e
+    jmp short 04db3h                          ; eb 0e
     mov al, byte [bp-010h]                    ; 8a 46 f0
     and AL, strict byte 0feh                  ; 24 fe
@@ -6732,19 +6776,19 @@
     mov dx, strict word 00018h                ; ba 18 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 74 c8
-    jmp near 04f8ch                           ; e9 ef 01
+    call 0160eh                               ; e8 55 c8
+    jmp near 04fabh                           ; e9 ef 01
     or bl, 008h                               ; 80 cb 08
     xor bh, bh                                ; 30 ff
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 63 c8
+    call 0160eh                               ; e8 44 c8
     mov al, byte [bp-008h]                    ; 8a 46 f8
     test AL, strict byte 002h                 ; a8 02
-    je short 04dbfh                           ; 74 0d
+    je short 04ddeh                           ; 74 0d
     or AL, strict byte 008h                   ; 0c 08
     mov byte [bp-006h], al                    ; 88 46 fa
     movzx bx, al                              ; 0f b6 d8
     mov dx, 00096h                            ; ba 96 00
-    jmp short 04dcdh                          ; eb 0e
+    jmp short 04dech                          ; eb 0e
     mov al, byte [bp-010h]                    ; 8a 46 f0
     or AL, strict byte 002h                   ; 0c 02
@@ -6753,19 +6797,19 @@
     mov dx, strict word 00018h                ; ba 18 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 3b c8
-    jmp near 04f8ch                           ; e9 b6 01
+    call 0160eh                               ; e8 1c c8
+    jmp near 04fabh                           ; e9 b6 01
     and bl, 0f7h                              ; 80 e3 f7
     xor bh, bh                                ; 30 ff
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 2a c8
+    call 0160eh                               ; e8 0b c8
     mov al, byte [bp-008h]                    ; 8a 46 f8
     test AL, strict byte 002h                 ; a8 02
-    je short 04df8h                           ; 74 0d
+    je short 04e17h                           ; 74 0d
     and AL, strict byte 0f7h                  ; 24 f7
     mov byte [bp-006h], al                    ; 88 46 fa
     movzx bx, al                              ; 0f b6 d8
     mov dx, 00096h                            ; ba 96 00
-    jmp short 04e06h                          ; eb 0e
+    jmp short 04e25h                          ; eb 0e
     mov al, byte [bp-010h]                    ; 8a 46 f0
     and AL, strict byte 0fdh                  ; 24 fd
@@ -6774,8 +6818,8 @@
     mov dx, strict word 00018h                ; ba 18 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 02 c8
-    jmp near 04f8ch                           ; e9 7d 01
+    call 0160eh                               ; e8 e3 c7
+    jmp near 04fabh                           ; e9 7d 01
     test byte [bp-008h], 003h                 ; f6 46 f8 03
-    jne near 04f8ch                           ; 0f 85 75 01
+    jne near 04fabh                           ; 0f 85 75 01
     mov al, byte [bp-010h]                    ; 8a 46 f0
     or AL, strict byte 020h                   ; 0c 20
@@ -6784,5 +6828,5 @@
     mov dx, strict word 00018h                ; ba 18 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 e3 c7
+    call 0160eh                               ; e8 c4 c7
     mov bl, byte [bp-00eh]                    ; 8a 5e f2
     xor bl, 020h                              ; 80 f3 20
